<script type="text/javascript">
  (async function() {
    if (!window.dimPromise) {
      const prom = {};
      prom.promise = new Promise((resolve) => (prom.resolve = resolve));
      window.dimPromise = prom;
      /* will be resolved by DimConf script */
    }

    const dim = await dimPromise.promise;
    dim.utils.genNodeTemplate("dim-cmd-server", {
    nodeName: {
      property: "name",
      label: RED._('node-red-dim/disCmd:disCmd.label.node-name')
    },
    nodeConf: {
      property: "cnf",
      label: RED._('node-red-dim/disCmd:disCmd.label.node-conf')
    },
    serviceName: {
      property: "serviceName",
      label: RED._('node-red-dim/disCmd:disCmd.label.service-name')
    },
    serviceDefinitions: [
      {
        property: "serviceDef",
        label: RED._('node-red-dim/disCmd:disCmd.label.service-definition')
      }
    ],
  });

    RED.nodes.registerType("dim-cmd-server", {
      category: 'network',
      color: '#F3B567',
      defaults: {
        name: { value: "" },
        cnf: { type: "dim-conf", required: true },
        serviceName: { value: "", required: true,
          validate: RED.validators.regex(dis.regExp.srvName)
        },
        serviceDef: { value: "", required: true,
          validate: function(d) {
            if (!d) { return false; }

            const res = d.match(dis.regExp.srvDefDescr);
            if (res) {
              d = d.slice(0, res.index); /* extract service definition */
              $('#node-input-serviceDef').val(d);
            }
            return dis.regExp.srvDefFormat.test(d);
          }
        }
      },
      icon: 'bridge.svg',
      inputs: 0,
      outputs: 1,
      label: function() {
        const def = (this.serviceName && this.serviceDef) ?
          " [ " + this.serviceDef + " ]" : "";
        return this.name || this.serviceName + def || "DIM CMD Server";
      }
    });
  }());
</script>

<script type="text/html" data-template-name="dim-cmd-server"></script>
